



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>sparklyr-R语言访问Spark的另外一种方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">sparklyr-R语言访问Spark的另外一种方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 21:10:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<div>
<ul><li>Connect to&nbsp;<a href="http://spark.apache.org/" rel="external nofollow noreferrer">Spark</a>&nbsp;from R. The sparklyr package provides a&nbsp;<br />complete&nbsp;<a href="https://github.com/hadley/dplyr" rel="external nofollow noreferrer">dplyr</a>&nbsp;backend.</li>
<li>Filter and aggregate Spark datasets then bring them into R for&nbsp;<br />analysis and visualization.</li>
<li>Use Spark&lt;u+2019&gt;s distributed&nbsp;<a href="http://spark.apache.org/docs/latest/mllib-guide.html" rel="external nofollow noreferrer">machine learning</a>&nbsp;library from R.</li>
<li>Create&nbsp;<a href="http://spark.rstudio.com/extensions.html" rel="external nofollow noreferrer">extensions</a>&nbsp;that call the full Spark API and provide&nbsp;<br />interfaces to Spark packages.</li></ul>
<div>
<h2>Installation</h2>
<p>You can install the&nbsp;<strong>sparklyr</strong>&nbsp;package from CRAN as follows:</p>
<div>
<pre class="prettyprint linenums"><code>install.packages("sparklyr")</code></pre>
</div>
<p>You should also install a local version of Spark for development purposes:</p>
<div>
<pre class="prettyprint linenums"><code>library(sparklyr)<br />
<a href="http://spark.rstudio.com/reference/spark_install.html" rel="external nofollow noreferrer">spark_install</a>(version = "1.6.2")</code></pre>
</div>
<p>To upgrade to the latest version of sparklyr, run the following command and restart your r session:</p>
<div>
<pre class="prettyprint linenums"><code>devtools::install_github("rstudio/sparklyr")</code></pre>
</div>
<p>If you use the RStudio IDE, you should also download the latest&nbsp;<a href="https://www.rstudio.com/products/rstudio/download/preview/" rel="external nofollow noreferrer">preview release</a>&nbsp;of the IDE which includes several enhancements for interacting with Spark (see the&nbsp;<a href="http://spark.rstudio.com/#rstudio-ide" rel="external nofollow noreferrer">RStudio IDE</a>&nbsp;section below for more details).</p>
</div>
<div>
<h2>Connecting to Spark</h2>
<p>You can connect to both local instances of Spark as well as remote Spark clusters. Here we&lt;u+2019&gt;ll connect to a local instance of Spark via the&nbsp;<a href="http://spark.rstudio.com/reference/sparklyr/latest/spark_connect.html" rel="external nofollow noreferrer">spark_connect</a>&nbsp;function:</p>
<div>
<pre class="prettyprint linenums"><code>library(sparklyr)<br />
sc &lt;- <a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_connect</a>(master = "local")</code></pre>
</div>
<p>The returned Spark connection (<code>sc</code>) provides a remote dplyr data source to the Spark cluster.</p>
<p>For more information on connecting to remote Spark clusters see the&nbsp;<a href="http://spark.rstudio.com/deployment.html" rel="external nofollow noreferrer">Deployment</a>&nbsp;section of the sparklyr website.</p>
</div>
<div>
<h2>Using dplyr</h2>
<p>We can new use all of the available dplyr verbs against the tables within the cluster.</p>
<p>We&lt;u+2019&gt;ll start by copying some datasets from R into the Spark cluster (note that you may need to install the nycflights13 and Lahman packages in order to execute this code):</p>
<div>
<pre class="prettyprint linenums"><code>install.packages(c("nycflights13", "Lahman"))</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>library(dplyr)<br />
iris_tbl &lt;- <a href="http://spark.rstudio.com/reference/reexports.html" rel="external nofollow noreferrer">copy_to</a>(sc, iris)<br />
flights_tbl &lt;- <a href="http://spark.rstudio.com/reference/reexports.html" rel="external nofollow noreferrer">copy_to</a>(sc, nycflights13::flights, "flights")<br />
batting_tbl &lt;- <a href="http://spark.rstudio.com/reference/reexports.html" rel="external nofollow noreferrer">copy_to</a>(sc, Lahman::Batting, "batting")<br />
src_tbls(sc)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## [1] "batting" "flights" "iris"</code></pre>
</div>
<p>To start with here&lt;u+2019&gt;s a simple filtering example:</p>
<div>
<pre class="prettyprint linenums"><code># filter by departure delay and print the first few records<br />
flights_tbl %&gt;% filter(dep_delay == 2)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## Source:   query [6,233 x 19]<br />
## Database: spark connection master=local[8] app=sparklyr local=TRUE<br />
##<br />
##     year month   day dep_time sched_dep_time dep_delay arr_time<br />
##    &lt;int&gt; &lt;int&gt; &lt;int&gt;    &lt;int&gt;          &lt;int&gt;     &lt;dbl&gt;    &lt;int&gt;<br />
## 1   2013     1     1      517            515         2      830<br />
## 2   2013     1     1      542            540         2      923<br />
## 3   2013     1     1      702            700         2     1058<br />
## 4   2013     1     1      715            713         2      911<br />
## 5   2013     1     1      752            750         2     1025<br />
## 6   2013     1     1      917            915         2     1206<br />
## 7   2013     1     1      932            930         2     1219<br />
## 8   2013     1     1     1028           1026         2     1350<br />
## 9   2013     1     1     1042           1040         2     1325<br />
## 10  2013     1     1     1231           1229         2     1523<br />
## # ... with 6,223 more rows, and 12 more variables: sched_arr_time &lt;int&gt;,<br />
## #   arr_delay &lt;dbl&gt;, carrier &lt;chr&gt;, flight &lt;int&gt;, tailnum &lt;chr&gt;,<br />
## #   origin &lt;chr&gt;, dest &lt;chr&gt;, air_time &lt;dbl&gt;, distance &lt;dbl&gt;, hour &lt;dbl&gt;,<br />
## #   minute &lt;dbl&gt;, time_hour &lt;dbl&gt;</code></pre>
</div>
<p><a href="https://cran.r-project.org/package=dplyr" rel="external nofollow noreferrer">Introduction to dplyr</a>&nbsp;provides additional dplyr examples you can try. For example, consider the last example from the tutorial which plots data on flight delays:</p>
<div>
<pre class="prettyprint linenums"><code>delay &lt;- flights_tbl %&gt;%<br />
  group_by(tailnum) %&gt;%<br />
  summarise(count = n(), dist = mean(distance), delay = mean(arr_delay)) %&gt;%<br />
  filter(count &gt; 20, dist &lt; 2000, !is.na(delay)) %&gt;%<br />
  collect

# plot delays<br />
library(ggplot2)<br />
ggplot(delay, aes(dist, delay)) +<br />
  geom_point(aes(size = count), alpha = 1/2) +<br />
  geom_smooth() +<br />
  scale_size_area(max_size = 2)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## `geom_smooth()` using method = 'gam'</code></pre>
</div>
<p><img referrerpolicy="no-referrer"src="http://spark.rstudio.com/home/README_files/figure-markdown_github/ggplot2-1.png" /></p>
<div>
<h3>Window Functions</h3>
<p>dplyr&nbsp;<a href="https://cran.r-project.org/package=dplyr" rel="external nofollow noreferrer">window functions</a>&nbsp;are also supported, for example:</p>
<div>
<pre class="prettyprint linenums"><code>batting_tbl %&gt;%<br />
  select(playerID, yearID, teamID, G, AB:H) %&gt;%<br />
  arrange(playerID, yearID, teamID) %&gt;%<br />
  group_by(playerID) %&gt;%<br />
  filter(min_rank(desc(H)) &lt;= 2 &amp; H &gt; 0)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## Source:   query [2.562e+04 x 7]<br />
## Database: spark connection master=local[8] app=sparklyr local=TRUE<br />
## Groups: playerID<br />
##<br />
##     playerID yearID teamID     G    AB     R     H<br />
##        &lt;chr&gt;  &lt;int&gt;  &lt;chr&gt; &lt;int&gt; &lt;int&gt; &lt;int&gt; &lt;int&gt;<br />
## 1  abbotpa01   2000    SEA    35     5     1     2<br />
## 2  abbotpa01   2004    PHI    10    11     1     2<br />
## 3  abnersh01   1992    CHA    97   208    21    58<br />
## 4  abnersh01   1990    SDN    91   184    17    45<br />
## 5  abreujo02   2015    CHA   154   613    88   178<br />
## 6  abreujo02   2014    CHA   145   556    80   176<br />
## 7  acevejo01   2001    CIN    18    34     1     4<br />
## 8  acevejo01   2004    CIN    39    43     0     2<br />
## 9  adamsbe01   1919    PHI    78   232    14    54<br />
## 10 adamsbe01   1918    PHI    84   227    10    40<br />
## # ... with 2.561e+04 more rows</code></pre>
</div>
<p>For additional documentation on using dplyr with Spark see the&nbsp;<a href="http://spark.rstudio.com/dplyr.html" rel="external nofollow noreferrer">dplyr</a>&nbsp;section of the sparklyr website.</p>
</div>
</div>
<div>
<h2>Using SQL</h2>
<p>It&lt;u+2019&gt;s also possible to execute SQL queries directly against tables within a Spark cluster. The&nbsp;<code>spark_connection</code>&nbsp;object implements a&nbsp;<a href="https://github.com/rstats-db/DBI" rel="external nofollow noreferrer">DBI</a>&nbsp;interface for Spark, so you can use&nbsp;<code>dbGetQuery</code>&nbsp;to execute SQL and return the result as an R data frame:</p>
<div>
<pre class="prettyprint linenums"><code>library(DBI)<br />
iris_preview &lt;- dbGetQuery(sc, "SELECT * FROM iris LIMIT 10")<br />
iris_preview</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>##    Sepal_Length Sepal_Width Petal_Length Petal_Width Species<br />
## 1           5.1         3.5          1.4         0.2  setosa<br />
## 2           4.9         3.0          1.4         0.2  setosa<br />
## 3           4.7         3.2          1.3         0.2  setosa<br />
## 4           4.6         3.1          1.5         0.2  setosa<br />
## 5           5.0         3.6          1.4         0.2  setosa<br />
## 6           5.4         3.9          1.7         0.4  setosa<br />
## 7           4.6         3.4          1.4         0.3  setosa<br />
## 8           5.0         3.4          1.5         0.2  setosa<br />
## 9           4.4         2.9          1.4         0.2  setosa<br />
## 10          4.9         3.1          1.5         0.1  setosa</code></pre>
</div>
</div>
<div>
<h2>Machine Learning</h2>
<p>You can orchestrate machine learning algorithms in a Spark cluster via the&nbsp;<a href="http://spark.apache.org/docs/latest/mllib-guide.html" rel="external nofollow noreferrer">machine learning</a>&nbsp;functions within&nbsp;<strong>sparklyr</strong>. These functions connect to a set of high-level APIs built on top of DataFrames that help you create and tune machine learning workflows.</p>
<p>Here&lt;u+2019&gt;s an example where we use&nbsp;<a href="http://spark.rstudio.com/reference/sparklyr/latest/ml_linear_regression.html" rel="external nofollow noreferrer">ml_linear_regression</a>&nbsp;to fit a linear regression model. We&lt;u+2019&gt;ll use the built-in&nbsp;<code>mtcars</code>&nbsp;dataset, and see if we can predict a car&lt;u+2019&gt;s fuel consumption (<code>mpg</code>) based on its weight (<code>wt</code>), and the number of cylinders the engine contains (<code>cyl</code>). We&lt;u+2019&gt;ll assume in each case that the relationship between&nbsp;<code>mpg</code>&nbsp;and each of our features is linear.</p>
<div>
<pre class="prettyprint linenums"><code># copy mtcars into spark<br />
mtcars_tbl &lt;- <a href="http://spark.rstudio.com/reference/reexports.html" rel="external nofollow noreferrer">copy_to</a>(sc, mtcars)

# transform our data set, and then partition into 'training', 'test'<br />
partitions &lt;- mtcars_tbl %&gt;%<br />
  filter(hp &gt;= 100) %&gt;%<br />
  mutate(cyl8 = cyl == 8) %&gt;%<br />
  <a href="http://spark.rstudio.com/reference/sdf_partition.html" rel="external nofollow noreferrer">sdf_partition</a>(training = 0.5, test = 0.5, seed = 1099)

# fit a linear model to the training dataset<br />
fit &lt;- partitions$training %&gt;%<br />
  <a href="http://spark.rstudio.com/reference/ml_linear_regression.html" rel="external nofollow noreferrer">ml_linear_regression</a>(response = "mpg", features = c("wt", "cyl"))</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## * No rows dropped by 'na.omit' call</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>fit</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## Call: ml_linear_regression(., response = "mpg", features = c("wt", "cyl"))<br />
##<br />
## Coefficients:<br />
## (Intercept)          wt         cyl<br />
##   37.066699   -2.309504   -1.639546</code></pre>
</div>
<p>For linear regression models produced by Spark, we can use&nbsp;<code>summary()</code>&nbsp;to learn a bit more about the quality of our fit, and the statistical significance of each of our predictors.</p>
<div>
<pre class="prettyprint linenums"><code>summary(fit)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## Call: ml_linear_regression(., response = "mpg", features = c("wt", "cyl"))<br />
##<br />
## Deviance Residuals::<br />
##     Min      1Q  Median      3Q     Max<br />
## -2.6881 -1.0507 -0.4420  0.4757  3.3858<br />
##<br />
## Coefficients:<br />
##             Estimate Std. Error t value  Pr(&gt;|t|)<br />
## (Intercept) 37.06670    2.76494 13.4059 2.981e-07 ***<br />
## wt          -2.30950    0.84748 -2.7252   0.02341 *<br />
## cyl         -1.63955    0.58635 -2.7962   0.02084 *<br />
## ---<br />
## Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1<br />
##<br />
## R-Squared: 0.8665<br />
## Root Mean Squared Error: 1.799</code></pre>
</div>
<p>Spark machine learning supports a wide array of algorithms and feature transformations and as illustrated above it&lt;u+2019&gt;s easy to chain these functions together with dplyr pipelines. To learn more see the&nbsp;<a href="http://spark.rstudio.com/mllib.html" rel="external nofollow noreferrer">machine learning</a>&nbsp;section.</p>
</div>
<div>
<h2>Reading and Writing Data</h2>
<p>You can read and write data in CSV, JSON, and Parquet formats. Data can be stored in HDFS, S3, or on the local filesystem of cluster nodes.</p>
<div>
<pre class="prettyprint linenums"><code>temp_csv &lt;- tempfile(fileext = ".csv")<br />
temp_parquet &lt;- tempfile(fileext = ".parquet")<br />
temp_json &lt;- tempfile(fileext = ".json")

<a href="http://spark.rstudio.com/reference/spark_write_csv.html" rel="external nofollow noreferrer">spark_write_csv</a>(iris_tbl, temp_csv)<br />
iris_csv_tbl &lt;- <a href="http://spark.rstudio.com/reference/spark_read_csv.html" rel="external nofollow noreferrer">spark_read_csv</a>(sc, "iris_csv", temp_csv)

<a href="http://spark.rstudio.com/reference/spark_write_parquet.html" rel="external nofollow noreferrer">spark_write_parquet</a>(iris_tbl, temp_parquet)<br />
iris_parquet_tbl &lt;- <a href="http://spark.rstudio.com/reference/spark_read_parquet.html" rel="external nofollow noreferrer">spark_read_parquet</a>(sc, "iris_parquet", temp_parquet)

<a href="http://spark.rstudio.com/reference/spark_write_json.html" rel="external nofollow noreferrer">spark_write_json</a>(iris_tbl, temp_json)<br />
iris_json_tbl &lt;- <a href="http://spark.rstudio.com/reference/spark_read_json.html" rel="external nofollow noreferrer">spark_read_json</a>(sc, "iris_json", temp_json)

src_tbls(sc)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## [1] "batting"      "flights"      "iris"         "iris_csv"<br />
## [5] "iris_json"    "iris_parquet" "mtcars"</code></pre>
</div>
</div>
<div>
<h2>Extensions</h2>
<p>The facilities used internally by sparklyr for its dplyr and machine learning interfaces are available to extension packages. Since Spark is a general purpose cluster computing system there are many potential applications for extensions (e.g.&lt;u+00a0&gt;interfaces to custom machine learning pipelines, interfaces to 3rd party Spark packages, etc.).</p>
<p>Here&lt;u+2019&gt;s a simple example that wraps a Spark text file line counting function with an R function:</p>
<div>
<pre class="prettyprint linenums"><code># write a CSV<br />
tempfile &lt;- tempfile(fileext = ".csv")<br />
write.csv(nycflights13::flights, tempfile, row.names = FALSE, na = "")

# define an R interface to Spark line counting<br />
count_lines &lt;- function(sc, path) {<br />
  <a href="http://spark.rstudio.com/reference/spark-api.html" rel="external nofollow noreferrer">spark_context</a>(sc) %&gt;%<br />
    <a href="http://spark.rstudio.com/reference/invoke.html" rel="external nofollow noreferrer">invoke</a>("textFile", path, 1L) %&gt;%<br />
      <a href="http://spark.rstudio.com/reference/invoke.html" rel="external nofollow noreferrer">invoke</a>("count")<br />
}

# call spark to count the lines of the CSV<br />
count_lines(sc, tempfile)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## [1] 336777</code></pre>
</div>
<p>To learn more about creating extensions see the&nbsp;<a href="http://spark.rstudio.com/extensions.html" rel="external nofollow noreferrer">Extensions</a>&nbsp;section of the sparklyr website.</p>
</div>
<div>
<h2>Table Utilities</h2>
<p>You can cache a table into memory with:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/tbl_cache.html" rel="external nofollow noreferrer">tbl_cache</a>(sc, "batting")</code></pre>
</div>
<p>and unload from memory using:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/tbl_uncache.html" rel="external nofollow noreferrer">tbl_uncache</a>(sc, "batting")</code></pre>
</div>
</div>
<div>
<h2>Connection Utilities</h2>
<p>You can view the Spark web console using the&nbsp;<code>spark_web</code>&nbsp;function:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/spark_web.html" rel="external nofollow noreferrer">spark_web</a>(sc)</code></pre>
</div>
<p>You can show the log using the&nbsp;<code>spark_log</code>&nbsp;function:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/spark_log.html" rel="external nofollow noreferrer">spark_log</a>(sc, n = 10)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## 17/02/03 15:34:17 INFO DAGScheduler: Submitting 1 missing tasks from ResultStage 91 (/var/folders/fz/v6wfsg2x1fb1rw4f6r0x4jwm0000gn/T//RtmpZqMbDE/file8f2b280ac4e5.csv MapPartitionsRDD[363] at textFile at NativeMethodAccessorImpl.java:-2)<br />
## 17/02/03 15:34:17 INFO TaskSchedulerImpl: Adding task set 91.0 with 1 tasks<br />
## 17/02/03 15:34:17 INFO TaskSetManager: Starting task 0.0 in stage 91.0 (TID 177, localhost, partition 0,PROCESS_LOCAL, 2430 bytes)<br />
## 17/02/03 15:34:17 INFO Executor: Running task 0.0 in stage 91.0 (TID 177)<br />
## 17/02/03 15:34:17 INFO HadoopRDD: Input split: file:/var/folders/fz/v6wfsg2x1fb1rw4f6r0x4jwm0000gn/T/RtmpZqMbDE/file8f2b280ac4e5.csv:0+33313106<br />
## 17/02/03 15:34:17 INFO Executor: Finished task 0.0 in stage 91.0 (TID 177). 2082 bytes result sent to driver<br />
## 17/02/03 15:34:17 INFO TaskSetManager: Finished task 0.0 in stage 91.0 (TID 177) in 116 ms on localhost (1/1)<br />
## 17/02/03 15:34:17 INFO DAGScheduler: ResultStage 91 (count at NativeMethodAccessorImpl.java:-2) finished in 0.117 s<br />
## 17/02/03 15:34:17 INFO TaskSchedulerImpl: Removed TaskSet 91.0, whose tasks have all completed, from pool<br />
## 17/02/03 15:34:17 INFO DAGScheduler: Job 61 finished: count at NativeMethodAccessorImpl.java:-2, took 0.119612 s</code></pre>
</div>
<p>Finally, we disconnect from Spark:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_disconnect</a>(sc)</code></pre>
</div>
</div>
<div>
<h2>RStudio IDE</h2>
<p>The latest RStudio&nbsp;<a href="https://www.rstudio.com/products/rstudio/download/preview/" rel="external nofollow noreferrer">Preview Release</a>&nbsp;of the RStudio IDE includes integrated support for Spark and the sparklyr package, including tools for:</p>
<ul><li>Creating and managing Spark connections</li>
<li>Browsing the tables and columns of Spark DataFrames</li>
<li>Previewing the first 1,000 rows of Spark DataFrames</li></ul>
<p>Once you&lt;u+2019&gt;ve installed the sparklyr package, you should find a new&nbsp;<strong>Spark</strong>&nbsp;pane within the IDE. This pane includes a&nbsp;<strong>New Connection</strong>&nbsp;dialog which can be used to make connections to local or remote Spark instances:</p>
<p><img referrerpolicy="no-referrer"src="http://spark.rstudio.com/home/README_files/images/spark-connect.png" /></p>
<p>Once you&lt;u+2019&gt;ve connected to Spark you&lt;u+2019&gt;ll be able to browse the tables contained within the Spark cluster:</p>
<p><img referrerpolicy="no-referrer"src="http://spark.rstudio.com/home/README_files/images/spark-tab.png" /></p>
<p>The Spark DataFrame preview uses the standard RStudio data viewer:</p>
<p><img referrerpolicy="no-referrer"src="http://spark.rstudio.com/home/README_files/images/spark-dataview.png" /></p>
<p>The RStudio IDE features for sparklyr are available now as part of the&nbsp;<a href="https://www.rstudio.com/products/rstudio/download/preview/" rel="external nofollow noreferrer">RStudio Preview Release</a>.</p>
</div>
<div>
<h2>Using H2O</h2>
<p><a href="https://cran.r-project.org/package=rsparkling" rel="external nofollow noreferrer">rsparkling</a>&nbsp;is a CRAN package from&nbsp;<a href="http://h2o.ai/" rel="external nofollow noreferrer">H2O</a>&nbsp;that extends&nbsp;<a href="http://spark.rstudio.com/" rel="external nofollow noreferrer">sparklyr</a>&nbsp;to provide an interface into&nbsp;<a href="https://github.com/h2oai/sparkling-water" rel="external nofollow noreferrer">Sparkling Water</a>. For instance, the following example installs, configures and runs&nbsp;<a href="http://docs.h2o.ai/h2o/latest-stable/h2o-docs/data-science/glm.html" rel="external nofollow noreferrer">h2o.glm</a>:</p>
<div>
<pre class="prettyprint linenums"><code>options(rsparkling.sparklingwater.version = "1.6.8")

library(rsparkling)<br />
library(sparklyr)<br />
library(dplyr)<br />
library(h2o)

sc &lt;- <a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_connect</a>(master = "local", version = "1.6.2")<br />
mtcars_tbl &lt;- <a href="http://spark.rstudio.com/reference/reexports.html" rel="external nofollow noreferrer">copy_to</a>(sc, mtcars, "mtcars")

mtcars_h2o &lt;- as_h2o_frame(sc, mtcars_tbl, strict_version_check = FALSE)

mtcars_glm &lt;- h2o.glm(x = c("wt", "cyl"),<br />
                      y = "mpg",<br />
                      training_frame = mtcars_h2o,<br />
                      lambda_search = TRUE)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>mtcars_glm</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## Model Details:<br />
## ==============<br />
##<br />
## H2ORegressionModel: glm<br />
## Model ID:  GLM_model_R_1486164877174_1<br />
## GLM Model: summary<br />
##     family     link                              regularization<br />
## 1 gaussian identity Elastic Net (alpha = 0.5, lambda = 0.1013 )<br />
##                                                                lambda_search<br />
## 1 nlambda = 100, lambda.max = 10.132, lambda.min = 0.1013, lambda.1se = -1.0<br />
##   number_of_predictors_total number_of_active_predictors<br />
## 1                          2                           2<br />
##   number_of_iterations training_frame<br />
## 1                    0   frame_rdd_33<br />
##<br />
## Coefficients: glm coefficients<br />
##       names coefficients standardized_coefficients<br />
## 1 Intercept    38.941654                 20.090625<br />
## 2       cyl    -1.468783                 -2.623132<br />
## 3        wt    -3.034558                 -2.969186<br />
##<br />
## H2ORegressionMetrics: glm<br />
## ** Reported on training data. **<br />
##<br />
## MSE:  6.017684<br />
## RMSE:  2.453097<br />
## MAE:  1.940985<br />
## RMSLE:  0.1114801<br />
## Mean Residual Deviance :  6.017684<br />
## R^2 :  0.8289895<br />
## Null Deviance :1126.047<br />
## Null D.o.F. :31<br />
## Residual Deviance :192.5659<br />
## Residual D.o.F. :29<br />
## AIC :156.2425</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_disconnect</a>(sc)</code></pre>
</div>
</div>
<div>
<h2>Connecting through Livy</h2>
<p><a href="https://github.com/cloudera/livy" rel="external nofollow noreferrer">Livy</a>&nbsp;enables remote connections to Apache Spark clusters. Connecting to Spark clusters through Livy is&nbsp;<strong>under experimental development</strong>&nbsp;in&nbsp;<code>sparklyr</code>. Please post any feedback or questions as a GitHub issue as needed.</p>
<p>Before connecting to Livy, you will need the connection information to an existing service running Livy. Otherwise, to test&nbsp;<code>livy</code>&nbsp;in your local environment, you can install it and run it locally as follows:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/livy_install.html" rel="external nofollow noreferrer">livy_install</a>()</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/livy_service.html" rel="external nofollow noreferrer">livy_service_start</a>()</code></pre>
</div>
<p>To connect, use the Livy service address as&nbsp;<code>master</code>&nbsp;and&nbsp;<code>method = "livy"</code>&nbsp;in&nbsp;<code>spark_connect</code>. Once connection completes, use&nbsp;<code>sparklyr</code>&nbsp;as usual, for instance:</p>
<div>
<pre class="prettyprint linenums"><code>sc &lt;- <a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_connect</a>(master = "http://localhost:8998", method = "livy")<br />
<a href="http://spark.rstudio.com/reference/reexports.html" rel="external nofollow noreferrer">copy_to</a>(sc, iris)</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>## Source:   query [150 x 5]<br />
## Database: spark connection master=http://localhost:8998 app= local=FALSE<br />
##<br />
##    Sepal_Length Sepal_Width Petal_Length Petal_Width Species<br />
##           &lt;dbl&gt;       &lt;dbl&gt;        &lt;dbl&gt;       &lt;dbl&gt;   &lt;chr&gt;<br />
## 1           5.1         3.5          1.4         0.2  setosa<br />
## 2           4.9         3.0          1.4         0.2  setosa<br />
## 3           4.7         3.2          1.3         0.2  setosa<br />
## 4           4.6         3.1          1.5         0.2  setosa<br />
## 5           5.0         3.6          1.4         0.2  setosa<br />
## 6           5.4         3.9          1.7         0.4  setosa<br />
## 7           4.6         3.4          1.4         0.3  setosa<br />
## 8           5.0         3.4          1.5         0.2  setosa<br />
## 9           4.4         2.9          1.4         0.2  setosa<br />
## 10          4.9         3.1          1.5         0.1  setosa<br />
## # ... with 140 more rows</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_disconnect</a>(sc)</code></pre>
</div>
<p>Once you are done using&nbsp;<code>livy</code>&nbsp;locally, you should stop this service with:</p>
<div>
<pre class="prettyprint linenums"><code><a href="http://spark.rstudio.com/reference/livy_service.html" rel="external nofollow noreferrer">livy_service_stop</a>()</code></pre>
</div>
<p>To connect to remote&nbsp;<code>livy</code>&nbsp;clusters that support basic authentication connect as:</p>
<div>
<pre class="prettyprint linenums"><code>config &lt;- livy_config_auth("&lt;username&gt;", "&lt;password"&gt;)<br />
sc &lt;- <a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_connect</a>(master = "&lt;address&gt;", method = "livy", config = config)<br />
<a href="http://spark.rstudio.com/reference/spark-connections.html" rel="external nofollow noreferrer">spark_disconnect</a>(sc)</code></pre>
</div>
</div>
</div>
</div>
<div>
<h2>Links</h2>
<ul><li>Download from CRAN at&nbsp;<br /><a href="https://cran.r-project.org/package=sparklyr" rel="external nofollow noreferrer">https://&lt;u+200b&gt;cran.r-project.org/&lt;u+200b&gt;package=sparklyr</a></li>
<li>Report a bug at&nbsp;<br /><a href="https://github.com/rstudio/sparklyr/issues" rel="external nofollow noreferrer">https://&lt;u+200b&gt;github.com/&lt;u+200b&gt;rstudio/&lt;u+200b&gt;sparklyr/&lt;u+200b&gt;issues</a></li></ul>
<h2>License</h2>
<p>Apache License 2.0 | file&nbsp;<a href="http://spark.rstudio.com/LICENSE" rel="external nofollow noreferrer">LICENSE</a></p>
<h2>Developers</h2>
<ul><li>Javier Luraschi&nbsp;<br />Author, maintainer</li>
<li>Kevin Ushey&nbsp;<br />Author</li>
<li>JJ Allaire&nbsp;<br />Author</li>
<li>The Apache Software Foundation&nbsp;<br />Author, copyright&lt;u+00a0&gt;holder</li>
<li><a href="http://spark.rstudio.com/authors.html" rel="external nofollow noreferrer">All authors...</a></li></ul>
<div>
<h2>Dev status</h2>
<ul><li><img referrerpolicy="no-referrer"src="https://travis-ci.org/rstudio/sparklyr.svg?branch=master" /></li>
<li><img referrerpolicy="no-referrer"src="https://www.r-pkg.org/badges/version/sparklyr" /></li></ul>
</div>
</div>
</div>
<div>
<p>Developed by Javier Luraschi, Kevin Ushey, JJ Allaire, The Apache Software Foundation.</p>
</div>
<div>
<p>Site built with&nbsp;<a href="http://hadley.github.io/pkgdown/" rel="external nofollow noreferrer">pkgdown</a>.</p>
</div>
<p>参考&nbsp;http://spark.rstudio.com/</p>
<p>http://alitrack.com/2016/11/01/sparklyr-r%E8%AF%AD%E8%A8%80%E8%AE%BF%E9%97%AEspark%E7%9A%84%E5%8F%A6%E5%A4%96%E4%B8%80%E7%A7%8D%E6%96%B9%E6%B3%95/</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnv4mk8.html">ClickOnce部署（2）：自动更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3l349.html">php设计模式之Proxy&lpar;代理模式&rpar;和Facade&lpar;外观&rpar;设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjpond9.html">Java之XStream之下划线问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oky5z59.html">bzoj 3732 Network（最短路&plus;倍增 &vert; LCT）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1kez59.html">C中浮点数转字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm73169.html">清理Win8&period;1更新冗余的批处理代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdvgj8.html">【Echarts每天一例】-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z0lzj9.html">Zookeeper 笔记-角色</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzwp38.html">SSH简单项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jv71x8.html">VS2012编译log4cpp1&period;1&period;1版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e44x6x9.html">iview导航菜单updateOpened和updateActiveName的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6n3z9.html">Centos 中 service iptables stop 失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jrwxeq.html">CentOS ln 链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/902j3ymq.html">python 多线程队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveow6o9.html">WeUI中的Css详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl606z9.html">MYSQL SSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odk0m5q.html">第十二章 Ganglia监控Hadoop及Hbase集群性能&lpar;安装配置&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jem2248.html">WebPack系列之Proxy</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jvejz8.html">解决tomcat中jdk1&period;5运行日志相差8小时问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dyo5j8.html">canvas基础学习笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2y55o9.html">Linux 压缩、解压命令使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4ge5j9.html">【C&num;】非常重要的泛型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyzg7x9.html">Jupyter Notebook主题字体设置及自动代码补全</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w4oerq.html">Spring Cloud各组件超时总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1o0mg9.html">VHDL 例程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4g16k9.html">【Luogu P2764】最小路径覆盖问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyz15d9.html">BZOJ 1061&colon; &lbrack;Noi2008&rsqb;志愿者招募（线性规划与网络流）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyzol39.html">解决Geoserver请求跨域的几种思路，第二种思路用过</a>
			</li>
						<li><a href="https://www.batexi.com/a/960rpgn9.html">草珊瑚的redux使用方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvxjxj8.html">Python cmd中输入&amp;&num;39&semi;pip&amp;&num;39&semi; 不是内部或外部命令，也不是可运行的程序或批处理文件。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
